
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "osinfo.h"

OsInfo::OsDesc	OsInfo::OsD = OsInfo::UnSet;
const char*	OsInfo::v_str[6] = { "UnSet", "Windows 3.1", "Windows 95", 
								 "Windows 98", "Windows NT", "Unknown" };
void OsInfo::get_info(void)
{	OSVERSIONINFOEX osvi;

	OsD = Unknown;

	ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));

	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);

	if(!GetVersionEx((OSVERSIONINFO*)&osvi)) 
	{
		osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
   
		if(!GetVersionEx((OSVERSIONINFO*)&osvi))
			
			return;
	}

	switch(osvi.dwPlatformId) 
	{
		case VER_PLATFORM_WIN32_NT:	OsD = WinNT; break;

		case VER_PLATFORM_WIN32_WINDOWS:

			OsD = osvi.dwMajorVersion > 4 || osvi.dwMajorVersion == 4 
							&& osvi.dwMinorVersion > 0 ? Win98 : Win95; break;

		case VER_PLATFORM_WIN32s: OsD = Win31; break;

		default: OsD = Unknown; break;
	}
}
